//   Copyright (c)  1997-2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//#ifndef DUPFFFACTOR_LIFT_H
//#define DUPFFFACTOR_LIFT_H

#include "DUPFF.h"
#include "DUPFF.h"
#include "DUPFFlist.h"
#include "DUPI.h"
#include "DUPFFfactor_info1.h"

/* The factorization to be lifted is arranged in a "balanced" binary tree */
/* using the struct below.                                                */

struct DUPFFbiv_lift_struct;
typedef struct DUPFFbiv_lift_struct *DUPFFbiv_lifter;

struct DUPFFbiv_lift_struct
{
  DUPFF *g, *h;    /* p-adic expansions of the factors, to be found     */
  int r;           /* Expansion of f is up to p^r, of g,h up to p^(r-1) */
  DUPFF E;         /* The "error" in component p^r                      */
  DUPFF grecip, hrecip;  /* auxiliary values used during lifting        */
  DUPFFfactor_lifter g_lifter, h_lifter;
};


/***************************************************************************/

DUPFFbiv_lifter DUPFFbiv_lifter_ctor(DUPFF *g, DUPFF *h, DUPFFbiv_lifter g_lifter, DUPFFbiv_lifter h_lifter, int rmax);
void DUPFFbiv_lift_init(DUPFFfactor_info this);
void DUPFFbiv_lift_step(DUPFFbiv_lifter, DUPFF f_cmpt_r);
int DUPFFbiv_lift_output(DUPFF *factors, const DUPFFbiv_lifter this, int i);
void DUPFFbiv_lift_dtor(DUPFFbiv_lifter);

void DUPFFbiv_lift_revise(DUPFFfactor_info info);
void DUPFFbiv_lift_revise1(DUPFFfactor_info info, int height);


#endif
